<?php

/**
 * Implements the admin class for WordPress the little favicon plugin
 * @author: Edward de Leau <e@leau.net>
 * @copyright: Edward de Leau, http://edward.de.leau.net
 */
//ini_set('display_errors',1);	
//error_reporting(E_ALL|E_STRICT);
 
if (!class_exists("EdlLinkFaviconAdmin") && class_exists("EdlWPPluginAdmin") ) 
{
	class EdlLinkFaviconAdmin extends EdlWPPluginAdmin
	{
		static $mStrSpecificPluginOptionsName = 'wp_favicons_options';
		static $mSpecificPluginSettingsGroup = 'wp_favicons_settings_group';

		static $mStrSpecificPluginAdminPageTitle = 'WP_favicons'; 
		static $mStrSpecificPluginAdminMenuTitle = 'WP Favicons';
		static $mStrSpecificPluginAdminAccessLevel = 'administrator';
		static $mStrSpecificPluginAdminFile =  'wp_favicons';
		
		static $mStrRootUpload_dir = 'wp-favicons';	
		static $mStrCssUpload_dir = 'style';		
		static $mStrCssUpload_file = 'style.css';
		static $mStrCacheUpload_dir = 'cache';		
		   
		/*
		* constructor
		*/
		public function __construct() 
		{
			parent::SetPluginOptionsName(self::$mStrSpecificPluginOptionsName);
			parent::SetPluginSettingsGroup(self::$mSpecificPluginSettingsGroup);
			parent::RegisterPluginSettings();
			
			$arr_wp_favicons_options = array();
			$arr_wp_favicons_options['wp_favicons_use_cache'] = 0;
			$arr_wp_favicons_options['wp_favicons_show_in_content'] = 0;
			$arr_wp_favicons_options['wp_favicons_show_in_widgets'] = 0;
			$arr_wp_favicons_options['wp_favicons_ignore_filetypes'] = 0;
			$arr_wp_favicons_options['wp_favicons_stylesheet_content'] = 'width:10px!important;height:10px!important;margin-left:0px!important;margin-right:0px!important;padding-left:3px!important;padding-right:3px!important;padding-bottom: 0px!important;padding-top:0px!important;';
			$arr_wp_favicons_options['wp_favicons_stylesheet_widgets'] = 'width:10px!important;height:10px!important;margin-left:0px!important;margin-right:0px!important;padding-left:3px!important;padding-right:3px!important;padding-bottom: 0px!important;padding-top:0px!important;';
			$arr_wp_favicons_options['wp_favicons_exclude_filetypes'] = '.zip .pdf .arj';
						
			$upload_dir = wp_upload_dir();
			// physical directories
			$arr_wp_favicons_options['wp_favicons_upload_dir'] = $upload_dir['basedir'] . '/' . self::$mStrRootUpload_dir . '/';
			$arr_wp_favicons_options['wp_favicons_upload_dir_style'] = $arr_wp_favicons_options['wp_favicons_upload_dir'] . self::$mStrCssUpload_dir . '/' ;
			$arr_wp_favicons_options['wp_favicons_upload_dir_cache'] = $arr_wp_favicons_options['wp_favicons_upload_dir'] . self::$mStrCacheUpload_dir . '/' ;
			$arr_wp_favicons_options['wp_favicons_upload_dir_style_file'] = $arr_wp_favicons_options['wp_favicons_upload_dir_style'] . self::$mStrCssUpload_file;			
			// relative directories
			$arr_wp_favicons_options['wp_favicons_upload_url'] = $upload_dir['baseurl'] . '/' . self::$mStrRootUpload_dir . '/';
			$arr_wp_favicons_options['wp_favicons_upload_url_style'] = $arr_wp_favicons_options['wp_favicons_upload_url'] . self::$mStrCssUpload_dir . '/' ;
			$arr_wp_favicons_options['wp_favicons_upload_url_style_file'] = $arr_wp_favicons_options['wp_favicons_upload_url_style'] . self::$mStrCssUpload_file;			
			$arr_wp_favicons_options['wp_favicons_upload_url_cache'] = $arr_wp_favicons_options['wp_favicons_upload_url'] . self::$mStrCacheUpload_dir . '/' ;
			
			//print_r($arr_wp_favicons_options);			
			
			parent::SetPluginOptions($arr_wp_favicons_options);
			
			parent::SetOptionsPage( /*string*/ self::$mStrSpecificPluginAdminPageTitle, 
				 /*string*/ self::$mStrSpecificPluginAdminMenuTitle,
				 /*string*/ self::$mStrSpecificPluginAdminAccessLevel, 
				 /*string*/ self::$mStrSpecificPluginAdminFile);
			
			parent::AddOptionMenu();
					
		}
		
		function EdlLinkFaviconAdmin()
		{
			return $this->__construct();
		}		
		
		function AdminFormContent() {		
			$str_form_content = "";
			$str_form_content .= '<h2>WP Favicons v0.3 Settings</h2>';
			$str_form_content .= '<p><i>The WP Favicons plugin shows a favicon in front of each link. Do not forget to press the SAVE CHANGES button beneath after making changes!</i></p>';
			// --------------------------------------------------------------------------
			$str_form_content .= '<h3>Where to add</h3>';
			$str_form_content .= '<p><i>Select where you want us to add a favicon:</p></i>';
			$str_form_content .= '<table>';
			$str_form_content .= parent::CreateFieldCheckbox('wp_favicons_show_in_content', 'in the content', '');
			$str_form_content .= parent::CreateFieldCheckbox('wp_favicons_show_in_widgets', 'in the widgets', '');
			$str_form_content .= '</table>';
			// --------------------------------------------------------------------------
			$str_form_content .= '<h3>Use Eternal Cache</h3>';
			$str_form_content .= '<p><i>Unchecked = use Google for each call (probably faster)</i></p><p><i> Checked = ';
			$str_form_content .= 'serve the favicons from your own server: this has as benefit that you can replace ';
			$str_form_content .= 'favicons with your own e.g. handy for icons that are not served by Google such as Facebook games. ';
			$upload_dir = wp_upload_dir();
			$str_form_content .= '(<i>The icons are stored under <u>' . $upload_dir['basedir'] . '/wp-favicons/cache/</u> so that you can replace them in there.</i>)</i></p>';
			$str_form_content .= '<table>';
			$str_form_content .= parent::CreateFieldCheckbox('wp_favicons_use_cache', 'Use Cache', '');
			$str_form_content .= '</table>';	
			// --------------------------------------------------------------------------	
			$str_form_content .= '<h3>Your own stylesheet</h3>';
			$str_form_content .= '<p><i>';
			$str_form_content .= 'Change the default style for the content and the widget space e.g. the size of the icons (16x16 and 32x32 are regular sizes):';
			$str_form_content .= '</i></p>';
			$str_form_content .= '<table>';
			$str_form_content .= parent::CreateFieldText('wp_favicons_stylesheet_content', 'content: ', '');
			$str_form_content .= parent::CreateFieldText('wp_favicons_stylesheet_widgets', 'widgets: ', '');
			$str_form_content .= '</table>';			
			$str_form_content .= '<p><i>note: in some themes you might need to adjust the stylesheet for the links e.g. when you see something like '; 
			$str_form_content .= '#rightsidebar li a{display:block;} it means the wp links are displayed in a block so there is a newline between the favicon ';
			$str_form_content .= 'and the link</i></p>';
			// --------------------------------------------------------------------------	
			$str_form_content .= '<h3>FileTypes not to be touched</h3>';
			$str_form_content .= '<p><i>';
			$str_form_content .= 'URI\'s with the following extensions will not be touched:';
			$str_form_content .= '</i></p>';
			$str_form_content .= '<table>';
			$str_form_content .= parent::CreateFieldText('wp_favicons_exclude_filetypes', 'exclude: ', '');
			$str_form_content .= '</table>';
			// --------------------------------------------------------------------------	
			$str_form_content .= '<hr />';
			$str_form_content .= '<h3>Links</h3>';
			$str_form_content .= '<ol>';
			$str_form_content .= '<li><img src="http://www.google.com/s2/favicons?domain=wordpress.org" class="wp-favicon"> <a href="http://wordpress.org/extend/plugins/wp-favicons" target="_blank">Main homepage of the plugin</a><br />';
			$str_form_content .= '<li><img src="http://www.google.com/s2/favicons?domain=wordpress.org" class="wp-favicon"> <a href="http://wordpress.org/tags/wp-favicons?forum_id=10" target="_blank">Forum</a><br />';
			$str_form_content .= '<li><img src="http://www.google.com/s2/favicons?domain=edward.de.leau.net" class="wp-favicon"> <a href="http://edward.de.leau.net">weblog of author: Edward de Leau</a><br />';
			$str_form_content .= '<li><img src="http://www.google.com/s2/favicons?domain=wordpress.stackexchange.com" class="wp-favicon"> <a href="http://wordpress.stackexchange.com/questions/7065/plugin-that-inserts-favicon-next-to-links/7975#7975">StackExchange Thread</a><br />';
			$str_form_content .= '<li><img src="http://www.google.com/s2/favicons?domain=edward.de.leau.net" class="wp-favicon"> <a href="http://edward.de.leau.net/donate">donations are really welcome in this difficult times!</a><br />';	
			$str_form_content .= '<li><img src="http://www.google.com/s2/favicons?domain=dropbox.com" class="wp-favicon"> <a href="http://www.dropbox.com/referrals/NTc1OTgxMjk5">or... get a Free Dropbox account (you need it)</a> (by using this link you give me kudos)<br />';	
			$str_form_content .= '<li><img src="http://www.google.com/s2/favicons?domain=amazon.com" class="wp-favicon"> <a href="https://www.amazon.com/wishlist/T2A8VTUA53FQ">or... get me something from my Amazon wishlist :)</a><br />';
			
			$str_form_content .= '</ol>';

			return $str_form_content;
		}	
		
		/*
		 * function: Validator for form content
		 */
		function Validator( /*array*/ $arrLinkFaviconOptions)
		{		
			
			// save the stylesheet to the users upload directory
			$stylesheet = "/* WP-Favicons plugin */" .
			    ".wp-favicon-content{" . $arrLinkFaviconOptions['wp_favicons_stylesheet_content'] . "}\n" .
				".wp-favicon-widgets{" . $arrLinkFaviconOptions['wp_favicons_stylesheet_widgets'] . "}\n";
		
			// the following call to make sure the non editable variables are correct
			// @todo make smarter
			$upload_dir = wp_upload_dir();
			// physical directories
			$arrLinkFaviconOptions['wp_favicons_upload_dir'] = $upload_dir['basedir'] . '/' . self::$mStrRootUpload_dir . '/';
			$arrLinkFaviconOptions['wp_favicons_upload_dir_style'] = $arrLinkFaviconOptions['wp_favicons_upload_dir'] . self::$mStrCssUpload_dir . '/' ;
			$arrLinkFaviconOptions['wp_favicons_upload_dir_cache'] = $arrLinkFaviconOptions['wp_favicons_upload_dir'] . self::$mStrCacheUpload_dir . '/' ;
			$arrLinkFaviconOptions['wp_favicons_upload_dir_style_file'] = $arrLinkFaviconOptions['wp_favicons_upload_dir_style'] . self::$mStrCssUpload_file;			
			// relative directories
			$arrLinkFaviconOptions['wp_favicons_upload_url'] = $upload_dir['baseurl'] . '/' . self::$mStrRootUpload_dir . '/';
			$arrLinkFaviconOptions['wp_favicons_upload_url_style'] = $arrLinkFaviconOptions['wp_favicons_upload_url'] . self::$mStrCssUpload_dir . '/' ;
			$arrLinkFaviconOptions['wp_favicons_upload_url_style_file'] = $arrLinkFaviconOptions['wp_favicons_upload_url_style'] . self::$mStrCssUpload_file;			
			$arrLinkFaviconOptions['wp_favicons_upload_url_cache'] = $arrLinkFaviconOptions['wp_favicons_upload_url'] . self::$mStrCacheUpload_dir . '/' ;			
			
			EdlUtils::WriteFile($arrLinkFaviconOptions['wp_favicons_upload_dir_style'],$arrLinkFaviconOptions['wp_favicons_upload_dir_style_file'],$stylesheet);
			
			return $arrLinkFaviconOptions;
		}
		

		
	}	
}