<?php
/*
Plugin Name: WP-FavIcons
Plugin URI: http://wordpress.org/extend/plugins/wp-favicons/
Description: Faviconize your content and your widgets!
Author: Edward de Leau
Author URI: http://edward.de.leau.net
Version: 0.3

License: Copyright 2008,2009,2010,2011  edward de Leau  (email : deleau@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	
Installation:
	1. Upload the directory in your plugins directory
	2. Activate the plugin from your WordPress admin 'Plugins' page.
	3. There are no admin pages yet
	
Background:
    see: http://wordpress.stackexchange.com/questions/7875/plugin-that-inserts-favicon-next-to-links	
	
	1. note that we do not use inline images since they are not supported in all browsers
	   http://en.wikipedia.org/wiki/Data_URI_scheme (RFC 2397) as is MHTML http://en.wikipedia.org/wiki/MHTML (RFC 2557)
	   therefore we need a physical storage location.
*/
//ini_set('display_errors',1);	
//error_reporting(E_ALL|E_STRICT);

require_once(ABSPATH . '/wp-admin/includes/plugin.php');
require_once(ABSPATH . WPINC . '/pluggable.php');
//require_once(ABSPATH . WPINC. '/class-http.php');

require_once dirname( __FILE__  ) . '/edl-classes/class-EdlUtils.php';
require_once dirname( __FILE__  ) . '/edl-classes/class-EdlHtmlRef.php';
require_once dirname( __FILE__  ) . '/edl-classes/class-EdlCache.php';
require_once dirname( __FILE__  ) . '/edl-classes/class-EdlLinkFaviconContent.php';
require_once dirname( __FILE__  ) . '/edl-classes/class-EdlWPPluginAdmin.php';
require_once dirname( __FILE__  ) . '/edl-classes/class-EdlLinkFaviconAdmin.php';

	try 
	{		
		/* get admin options */
		
		$wp_favicon_admin = new EdlLinkFaviconAdmin();		
		$admin_options = $wp_favicon_admin->GetAdminOptions();
		
		/* insert style sheet */
		
		wp_register_style('EdlLinkFaviconStyle', /*string*/ $admin_options['wp_favicons_upload_url_style_file']);
		wp_enqueue_style('EdlLinkFaviconStyle');
		
		/* add icons in content */
		
		$wp_favicon_content = new EdlLinkFaviconContent('content');
		$wp_favicon_content->Init( /*array*/ $admin_options);	
		$wp_favicon_content->AddFilter();
		$wp_favicon_widgets = new EdlLinkFaviconContent('widgets');
		$wp_favicon_widgets->Init( /*array*/ $admin_options);	
		$wp_favicon_widgets->AddFilter();		
	}
	catch(Exception $e)
	{	   
		echo "ERROR: " . $e->getMessage() . "(go to http://wordpress.org/tags/wp-favicons?forum_id=10 for more help)";
		exit();
	}
